def temp-table tt field i as int.
def var h as handle.

DEFINE VARIABLE hQuery      AS HANDLE    NO-UNDO.
create buffer h for table "tt".

h:FIND-FIRST().
h:FIND-LAST().
h:FIND-UNIQUE().

DEFINE QUERY hQuery for tt.

hQuery:ADD-BUFFER(h).

def var INT1 as integer.

DEFINE QUERY hQuery FOR tt.

QUERY hQuery:FORWARD-ONLY = TRUE.
QUERY hQuery:QUERY-PREPARE("FOR EACH tt NO-LOCK").
QUERY hQuery:QUERY-OPEN().

/*
LT_NONE = 6209;
LT_SHARE = 6208;
LT_EXCLUSIVE = 6207;
LT_NO_WAIT = 6090;
*/

/* GET-NEXT */
QUERY hQuery:GET-NEXT().

QUERY hQuery:GET-NEXT(NO-LOCK).
QUERY hQuery:GET-NEXT(NO-LOCK, NO-WAIT).
QUERY hQuery:GET-NEXT(SHARE-LOCK).
QUERY hQuery:GET-NEXT(SHARE-LOCK, NO-WAIT).
QUERY hQuery:GET-NEXT(EXCLUSIVE-LOCK).
QUERY hQuery:GET-NEXT(EXCLUSIVE-LOCK, NO-WAIT).

QUERY hQuery:GET-NEXT(NO-LOCK, 0).
QUERY hQuery:GET-NEXT(NO-LOCK, 7).
QUERY hQuery:GET-NEXT(NO-LOCK, 7 + 1).
QUERY hQuery:GET-NEXT(SHARE-LOCK, 0).
QUERY hQuery:GET-NEXT(SHARE-LOCK, 7).
QUERY hQuery:GET-NEXT(SHARE-LOCK, 7 + 1).
QUERY hQuery:GET-NEXT(EXCLUSIVE-LOCK, 0).
QUERY hQuery:GET-NEXT(EXCLUSIVE-LOCK, 7).
QUERY hQuery:GET-NEXT(EXCLUSIVE-LOCK, 7 + 1).
QUERY hQuery:GET-NEXT(7 + 1, NO-WAIT).
QUERY hQuery:GET-NEXT(7, NO-WAIT).
QUERY hQuery:GET-NEXT(0, NO-WAIT).

QUERY hQuery:GET-NEXT(NO-LOCK, INT1).
QUERY hQuery:GET-NEXT(SHARE-LOCK, INT1).
QUERY hQuery:GET-NEXT(EXCLUSIVE-LOCK, INT1).
QUERY hQuery:GET-NEXT(INT1, NO-WAIT).
QUERY hQuery:GET-NEXT(NO-LOCK, INT1 + 1).
QUERY hQuery:GET-NEXT(INT1 + 1, NO-WAIT).

QUERY hQuery:GET-NEXT(6209).
QUERY hQuery:GET-NEXT(6209, 6090).
QUERY hQuery:GET-NEXT(6209, 0).
QUERY hQuery:GET-NEXT(6208).
QUERY hQuery:GET-NEXT(6208, 6090).
QUERY hQuery:GET-NEXT(6208, 0).
QUERY hQuery:GET-NEXT(6207).
QUERY hQuery:GET-NEXT(6207, 6090).
QUERY hQuery:GET-NEXT(6207, 0).
QUERY hQuery:GET-NEXT(1111).
QUERY hQuery:GET-NEXT(2222, 3333).

/* GET-PREV */
QUERY hQuery:GET-PREV().

QUERY hQuery:GET-PREV(NO-LOCK).
QUERY hQuery:GET-PREV(NO-LOCK, NO-WAIT).
QUERY hQuery:GET-PREV(SHARE-LOCK).
QUERY hQuery:GET-PREV(SHARE-LOCK, NO-WAIT).
QUERY hQuery:GET-PREV(EXCLUSIVE-LOCK).
QUERY hQuery:GET-PREV(EXCLUSIVE-LOCK, NO-WAIT).

QUERY hQuery:GET-PREV(NO-LOCK, 0).
QUERY hQuery:GET-PREV(NO-LOCK, 7).
QUERY hQuery:GET-PREV(NO-LOCK, 7 + 1).
QUERY hQuery:GET-PREV(SHARE-LOCK, 0).
QUERY hQuery:GET-PREV(SHARE-LOCK, 7).
QUERY hQuery:GET-PREV(SHARE-LOCK, 7 + 1).
QUERY hQuery:GET-PREV(EXCLUSIVE-LOCK, 0).
QUERY hQuery:GET-PREV(EXCLUSIVE-LOCK, 7).
QUERY hQuery:GET-PREV(EXCLUSIVE-LOCK, 7 + 1).
QUERY hQuery:GET-PREV(7 + 1, NO-WAIT).
QUERY hQuery:GET-PREV(7, NO-WAIT).
QUERY hQuery:GET-PREV(0, NO-WAIT).

QUERY hQuery:GET-PREV(NO-LOCK, INT1).
QUERY hQuery:GET-PREV(SHARE-LOCK, INT1).
QUERY hQuery:GET-PREV(EXCLUSIVE-LOCK, INT1).
QUERY hQuery:GET-PREV(INT1, NO-WAIT).
QUERY hQuery:GET-PREV(NO-LOCK, INT1 + 1).
QUERY hQuery:GET-PREV(INT1 + 1, NO-WAIT).

QUERY hQuery:GET-PREV(6209).
QUERY hQuery:GET-PREV(6209, 6090).
QUERY hQuery:GET-PREV(6209, 0).
QUERY hQuery:GET-PREV(6208).
QUERY hQuery:GET-PREV(6208, 6090).
QUERY hQuery:GET-PREV(6208, 0).
QUERY hQuery:GET-PREV(6207).
QUERY hQuery:GET-PREV(6207, 6090).
QUERY hQuery:GET-PREV(6207, 0).
QUERY hQuery:GET-PREV(1111).
QUERY hQuery:GET-PREV(2222, 3333).


/* GET-FIRST */
QUERY hQuery:GET-FIRST().

QUERY hQuery:GET-FIRST(NO-LOCK).
QUERY hQuery:GET-FIRST(NO-LOCK, NO-WAIT).
QUERY hQuery:GET-FIRST(SHARE-LOCK).
QUERY hQuery:GET-FIRST(SHARE-LOCK, NO-WAIT).
QUERY hQuery:GET-FIRST(EXCLUSIVE-LOCK).
QUERY hQuery:GET-FIRST(EXCLUSIVE-LOCK, NO-WAIT).

QUERY hQuery:GET-FIRST(NO-LOCK, 0).
QUERY hQuery:GET-FIRST(NO-LOCK, 7).
QUERY hQuery:GET-FIRST(NO-LOCK, 7 + 1).
QUERY hQuery:GET-FIRST(SHARE-LOCK, 0).
QUERY hQuery:GET-FIRST(SHARE-LOCK, 7).
QUERY hQuery:GET-FIRST(SHARE-LOCK, 7 + 1).
QUERY hQuery:GET-FIRST(EXCLUSIVE-LOCK, 0).
QUERY hQuery:GET-FIRST(EXCLUSIVE-LOCK, 7).
QUERY hQuery:GET-FIRST(EXCLUSIVE-LOCK, 7 + 1).
QUERY hQuery:GET-FIRST(7 + 1, NO-WAIT).
QUERY hQuery:GET-FIRST(7, NO-WAIT).
QUERY hQuery:GET-FIRST(0, NO-WAIT).

QUERY hQuery:GET-FIRST(NO-LOCK, INT1).
QUERY hQuery:GET-FIRST(SHARE-LOCK, INT1).
QUERY hQuery:GET-FIRST(EXCLUSIVE-LOCK, INT1).
QUERY hQuery:GET-FIRST(INT1, NO-WAIT).
QUERY hQuery:GET-FIRST(NO-LOCK, INT1 + 1).
QUERY hQuery:GET-FIRST(INT1 + 1, NO-WAIT).

QUERY hQuery:GET-FIRST(6209).
QUERY hQuery:GET-FIRST(6209, 6090).
QUERY hQuery:GET-FIRST(6209, 0).
QUERY hQuery:GET-FIRST(6208).
QUERY hQuery:GET-FIRST(6208, 6090).
QUERY hQuery:GET-FIRST(6208, 0).
QUERY hQuery:GET-FIRST(6207).
QUERY hQuery:GET-FIRST(6207, 6090).
QUERY hQuery:GET-FIRST(6207, 0).
QUERY hQuery:GET-FIRST(1111).
QUERY hQuery:GET-FIRST(2222, 3333).

/* GET-LAST */
QUERY hQuery:GET-LAST().

QUERY hQuery:GET-LAST(NO-LOCK).
QUERY hQuery:GET-LAST(NO-LOCK, NO-WAIT).
QUERY hQuery:GET-LAST(SHARE-LOCK).
QUERY hQuery:GET-LAST(SHARE-LOCK, NO-WAIT).
QUERY hQuery:GET-LAST(EXCLUSIVE-LOCK).
QUERY hQuery:GET-LAST(EXCLUSIVE-LOCK, NO-WAIT).

QUERY hQuery:GET-LAST(NO-LOCK, 0).
QUERY hQuery:GET-LAST(NO-LOCK, 7).
QUERY hQuery:GET-LAST(NO-LOCK, 7 + 1).
QUERY hQuery:GET-LAST(SHARE-LOCK, 0).
QUERY hQuery:GET-LAST(SHARE-LOCK, 7).
QUERY hQuery:GET-LAST(SHARE-LOCK, 7 + 1).
QUERY hQuery:GET-LAST(EXCLUSIVE-LOCK, 0).
QUERY hQuery:GET-LAST(EXCLUSIVE-LOCK, 7).
QUERY hQuery:GET-LAST(EXCLUSIVE-LOCK, 7 + 1).
QUERY hQuery:GET-LAST(7 + 1, NO-WAIT).
QUERY hQuery:GET-LAST(7, NO-WAIT).
QUERY hQuery:GET-LAST(0, NO-WAIT).

QUERY hQuery:GET-LAST(NO-LOCK, INT1).
QUERY hQuery:GET-LAST(SHARE-LOCK, INT1).
QUERY hQuery:GET-LAST(EXCLUSIVE-LOCK, INT1).
QUERY hQuery:GET-LAST(INT1, NO-WAIT).
QUERY hQuery:GET-LAST(NO-LOCK, INT1 + 1).
QUERY hQuery:GET-LAST(INT1 + 1, NO-WAIT).

QUERY hQuery:GET-LAST(6209).
QUERY hQuery:GET-LAST(6209, 6090).
QUERY hQuery:GET-LAST(6209, 0).
QUERY hQuery:GET-LAST(6208).
QUERY hQuery:GET-LAST(6208, 6090).
QUERY hQuery:GET-LAST(6208, 0).
QUERY hQuery:GET-LAST(6207).
QUERY hQuery:GET-LAST(6207, 6090).
QUERY hQuery:GET-LAST(6207, 0).
QUERY hQuery:GET-LAST(1111).
QUERY hQuery:GET-LAST(2222, 3333).

/* GET-CURRENT */
QUERY hQuery:GET-CURRENT().

QUERY hQuery:GET-CURRENT(NO-LOCK).
QUERY hQuery:GET-CURRENT(NO-LOCK, NO-WAIT).
QUERY hQuery:GET-CURRENT(SHARE-LOCK).
QUERY hQuery:GET-CURRENT(SHARE-LOCK, NO-WAIT).
QUERY hQuery:GET-CURRENT(EXCLUSIVE-LOCK).
QUERY hQuery:GET-CURRENT(EXCLUSIVE-LOCK, NO-WAIT).

QUERY hQuery:GET-CURRENT(NO-LOCK, 0).
QUERY hQuery:GET-CURRENT(NO-LOCK, 7).
QUERY hQuery:GET-CURRENT(NO-LOCK, 7 + 1).
QUERY hQuery:GET-CURRENT(SHARE-LOCK, 0).
QUERY hQuery:GET-CURRENT(SHARE-LOCK, 7).
QUERY hQuery:GET-CURRENT(SHARE-LOCK, 7 + 1).
QUERY hQuery:GET-CURRENT(EXCLUSIVE-LOCK, 0).
QUERY hQuery:GET-CURRENT(EXCLUSIVE-LOCK, 7).
QUERY hQuery:GET-CURRENT(EXCLUSIVE-LOCK, 7 + 1).
QUERY hQuery:GET-CURRENT(7 + 1, NO-WAIT).
QUERY hQuery:GET-CURRENT(7, NO-WAIT).
QUERY hQuery:GET-CURRENT(0, NO-WAIT).

QUERY hQuery:GET-CURRENT(NO-LOCK, INT1).
QUERY hQuery:GET-CURRENT(SHARE-LOCK, INT1).
QUERY hQuery:GET-CURRENT(EXCLUSIVE-LOCK, INT1).
QUERY hQuery:GET-CURRENT(INT1, NO-WAIT).
QUERY hQuery:GET-CURRENT(NO-LOCK, INT1 + 1).
QUERY hQuery:GET-CURRENT(INT1 + 1, NO-WAIT).

QUERY hQuery:GET-CURRENT(6209).
QUERY hQuery:GET-CURRENT(6209, 6090).
QUERY hQuery:GET-CURRENT(6209, 0).
QUERY hQuery:GET-CURRENT(6208).
QUERY hQuery:GET-CURRENT(6208, 6090).
QUERY hQuery:GET-CURRENT(6208, 0).
QUERY hQuery:GET-CURRENT(6207).
QUERY hQuery:GET-CURRENT(6207, 6090).
QUERY hQuery:GET-CURRENT(6207, 0).
QUERY hQuery:GET-CURRENT(1111).
QUERY hQuery:GET-CURRENT(2222, 3333).